#!/usr/bin/perl

#IMP - This program generates the html file for the @article, @book, & @techreport only

#USAGE - The first command line argument should be the bib file for input. The second command line argument should be the html file for output

#If command line arguments not given then by default it takes example.bib as input and output.html as output

$flag = 0;

if (!($ARGV[0] cmp ""))
{
	&usage();
	$flag = 1;
	unless (open(FP, "example.bib"))
	{
		die("cannot open input file example.bib");
	}
}

else
{
	unless (open(FP, "$ARGV[0]"))
	{
		die("cannot open input file $ARGV[0]");
	}
}

if (!($ARGV[1] cmp ""))
{
	if ($flag!=1){&usage()};
	unless (open(OUTFILE, ">output.html"))
	{
		die ("cannot open output file output.html\n");
	}
}

else
{
	unless (open(OUTFILE,">".$ARGV[1]))
	{
		die ("cannot open output file $ARGV[1]\n");
	}
}



$out_html="<html><body>\n<center><h1>References</h1></center>\n<table cellpadding=\"5\">\n";
print OUTFILE ($out_html);

$counter = 0;

while($line = <FP>)
{
	
	if ($line =~ /^[\t\s]*@/)
	{

		$author = "";
		$title = "";
		$journal = "";
		$volume = "";
		$pages = "";
		$month = "";
		$year = "";
		$type = "";

		$type = $line;
		($type,$junk)= split(/{/, $type);
		($junk,$type)= split(/@/, $type);
		$type = "\L$type\E";
		
		if($type eq "article" || $type eq "techreport" ||  $type eq "book")
		{
			$counter++;
		}

		$line = "";
	}


	elsif ($line =~ /^[ ]*[tT]itle[ ]*=[ ]*/)
	{
		$title = $line;
		($junk,$title)= split(/=/, $title);
		($junk,$title)= split(/[\"{]/, $title);
		($title,$junk)= split(/[\"}]/, $title);
	}


	elsif ($line =~ /^[ ]*[aA]uthor[ ]*=[ ]*/)
	{
		$author = $line;
		($junk,$author)= split(/=/, $author);
		($junk,$author)= split(/[\"{]/, $author);
		($author,$junk)= split(/[\"}]/, $author);
	}


	elsif ($line =~ /^[ ]*[pP]ages[ ]*=[ ]*/)
	{
		$pages = $line;
		($junk,$pages)= split(/=/, $pages);
		($junk,$pages)= split(/[\"{]/, $pages);
		if (!($pages eq ""))
		{
		($pages,$junk)= split(/[\"}]/, $pages);
		}
		else
		{
		($pages,$junk)= split(/,/, $junk);
		}
		
	}

	elsif ($line =~ /^[ ]*[yY]ear[ ]*=[ ]*/)
	{
		$year = $line;
		($junk,$year)= split(/=/, $year);
		($junk,$year)= split(/[\"{]/, $year);
		if (!($year eq ""))
		{
		($year,$junk)= split(/[\"}]/, $year);
		}
		else
		{
		($year,$junk)= split(/,/, $junk);
		}
	}


	elsif ($line =~ /^[ ]*[jJ]ournal[ ]*=[ ]*/)
	{
		$journal = $line;
		($junk,$journal)= split(/=/, $journal);
		($junk,$journal)= split(/[\"{]/, $journal);
		if (!($journal eq ""))
		{
		($journal,$junk)= split(/[\"}]/, $journal);
		}
		else
		{
		($journal,$junk)= split(/,/, $junk);		
		}
		
	}


	elsif ($line =~ /^[ ]*[vV]olume[ ]*=[ ]*/)
	{
		$volume = $line;
		($junk,$volume)= split(/=/, $volume);
		($junk,$volume)= split(/[\"{]/, $volume);
		if (!($volume eq ""))
		{
		($volume,$junk)= split(/[\"}]/, $volume);
		}
		else
		{
		($volume,$junk)= split(/,/, $junk);		
		}
	}

	elsif ($line =~ /^[ ]*[nN]umber[ ]*=[ ]*/)
	{
		$number = $line;
		($junk,$number)= split(/=/, $number);
		($junk,$number)= split(/[\"{]/, $number);
		if (!($number eq ""))
		{
		($number,$junk)= split(/[\"}]/, $number);
		}
		else
		{
		($number,$junk)= split(/,/, $junk);		
		}
	}

	elsif ($line =~ /^[ ]*[mM]onth[ ]*=[ ]*/)
	{
		$month = $line;
		($junk,$month)= split(/=/, $month);
		($junk,$month)= split(/[\"{]/, $month);
		if (!($month eq ""))
		{
		($month,$junk)= split(/[\"}]/, $month);
		}
		else
		{
		($month,$junk)= split(/,/, $junk);		
		}
	}	


	elsif ($line =~ /^[ ]*[iI]nstitution[ ]*=[ ]*/)
	{
		$institution = $line;
		($junk,$institution)= split(/=/, $institution);
		($junk,$institution)= split(/[\"{]/, $institution);
		if (!($institution eq ""))
		{
		($institution,$junk)= split(/[\"}]/, $institution);
		}
		else
		{
		($institution,$junk)= split(/,/, $junk);		
		}
	}


	elsif ($line =~ /^[ ]*[tT]type[ ]*=[ ]*/)
	{
		$type1 = $line;
		($junk,$type1)= split(/=/, $type1);
		($junk,$type1)= split(/[\"{]/, $type1);
		if (!($type1 eq ""))
		{
		($type1,$junk)= split(/[\"}]/, $type1);
		}
		else
		{
		($type1,$junk)= split(/,/, $junk);		
		}
	}


	elsif ($line =~ /^[ ]*[aA]ddress[ ]*=[ ]*/)
	{
		$address = $line;
		($junk,$address)= split(/=/, $address);
		($junk,$address)= split(/[\"{]/, $address);
		if (!($address eq ""))
		{
		($address,$junk)= split(/[\"}]/, $address);
		}
		else
		{
		($address,$junk)= split(/,/, $junk);		
		}
	}


	elsif ($line =~ /^[ ]*[pP]ublisher[ ]*=[ ]*/)
	{
		$publisher = $line;
		($junk,$publisher)= split(/=/, $publisher);
		($junk,$publisher)= split(/[\"{]/, $publisher);
		if (!($publisher eq ""))
		{
		($publisher,$junk)= split(/[\"}]/, $publisher);
		}
		else
		{
		($publisher,$junk)= split(/,/, $junk);		
		}
	}


	elsif ($line =~ /^[ ]*[eE]dition[ ]*=[ ]*/)
	{
		$edition = $line;
		($junk,$edition)= split(/=/, $edition);
		($junk,$edition)= split(/[\"{]/, $edition);
		if (!($edition eq ""))
		{
		($edition,$junk)= split(/[\"}]/, $edition);
		}
		else
		{
		($edition,$junk)= split(/,/, $junk);		
		}
	}


	elsif ($line =~ /^[ ]*[sS]eries[ ]*=[ ]*/)
	{
		$series = $line;
		($junk,$series)= split(/=/, $series);
		($junk,$series)= split(/[\"{]/, $series);
		if (!($series eq ""))
		{
		($series,$junk)= split(/[\"}]/, $series);
		}
		else
		{
		($series,$junk)= split(/,/, $junk);		
		}
	}



	elsif ($line =~ /^[ ]*}[ ]*/)	#i.e the end of one bib entry denoted by }
	{
		if ($counter>0)
		{
			$type = "\L$type\E";	#convert the whole string to lowercase

			if (!($type cmp "article"))
			{	
				
				$junk = " " . $month; 
				$month = $month cmp "" ?  $junk:"" ;

				$junk = " (" . $number . ") ";
				$number = $number cmp "" ? $junk:"";

				$junk = $journal . ", ";
				$journal = $journal cmp "" ? $junk:"" ;

				$junk = " " . $year;
				$year = $year cmp " " ? $junk:"" ;

				$junk = $author . ". ";
				$author = $author cmp "" ?  $junk:"";

				$junk = ": " . $pages;
				$pages = $pages cmp "" ?  $junk:"" ;

				$junk = $title . ". ";
				$title = $title cmp "" ?  $junk:"";

				$out_html = "\n<tr><td style=\"vertical-align: top;\">[" . $counter . "]<td> " . $author . $title . "<i>" . $journal . "</i>" . $volume . $number . $pages . $month . $year . ".\n</tr>\n" ;

				print OUTFILE ($out_html);
			}



			elsif (!($type cmp "techreport"))
			{	
				$junk = $author . ". ";
				$author = $author cmp "" ? $junk : "" ;

				$junk = $title . ". ";
				$title = $title cmp "" ? $junk : "" ;

				$junk = " ". $type1;
				$type1 = $type1 cmp "" ? $junk : "" ;

				$junk = " " . $number . ",";	
				$number = $number cmp "" ? $junk : "" ;

				$junk = " " . $institution . ",";
				$institution = $institution cmp " " ? $junk : "" ;
	
				$junk = " " . $address . ",";	
				$address = $address cmp "" ? $junk : "" ;

				$junk = " " . $month; 
				$month = $month cmp "" ? $junk : "" ;

				$junk = " " . $year;
				$year = $year cmp "" ? $junk : "" ;
				
				$out_html = "\n<tr><td style=\"vertical-align: top;\">[" . $counter . "]<td> " . $author . $title . $type1 . $number . $institution . $address . $month . $year . ".\n</tr>\n" ;

				print OUTFILE ($out_html);
			}


			elsif (!($type cmp "book"))
			{	
				$junk = $author . ". ";
				$author = $author cmp "" ? $junk : "" ;

				$junk = $title . ", ";
				$title = $title cmp "" ? $junk : "" ;

				$junk = "Volume " . $volume;
				$volume = $volume cmp "" ? $junk : "" ;

				$junk = " of " . $series . ".";
				$series = $series cmp "" ? $junk : "" ;

				$junk = " ". $publisher . ",";
				$publisher = $publisher cmp "" ? $junk : "" ;

				$junk = " " . $address . ",";
				$address = $address cmp "" ? $junk : "" ;

				$junk = " " . $edition . " Edition,";
				$edition = $edition cmp "" ? $junk : "" ;
				
				$junk = " " . $month; 
				$month = $month cmp "" ? $junk : "" ;

				$junk = " " . $year;
				$year = $year cmp "" ? $junk : "" ;

				$out_html = "\n<tr><td style=\"vertical-align: top;\">[" . $counter . "]<td> " . $author . "<i>". $title . "</i>" . $volume . "<i>" . $series . "</i>" . $publisher . $address . $edition . $month . $year . ".\n</tr>\n" ;

				print OUTFILE ($out_html);
			}




		}


	}	
}


$out_html="\n</table>\n<br>\n</body>\n</html>\n";
print OUTFILE ($out_html);
close OUTFILE;
close FP;

######################################################
#SUBROUTINE
######################################################
sub usage {
my $helpMessage = 
"Usage: perl_2.pl [BibFile] [HtmlFile]
Where:
BibFile	: Bib File path [default=example.bib]
HtmlFile: Html File path [default=output.html]";
print $helpMessage . "\n";
}
